;---------------------------------------------------------------------------
; Constants
;---------------------------------------------------------------------------

chars equ $a7 ;2

;---------------------------------------------------------------------------
; RAM Variables
;---------------------------------------------------------------------------

charp equ $80 ;5
chara equ $85 ;5
charb equ $8a ;5
charc equ $8f ;5
chard equ $94 ;5
chare equ $99 ;5
charf equ $9e ;5
charg equ $a3 ;5

;temp  equ $a9
line  equ $aa
count equ $ab
textptr equ $ac
savesp equ $ad



  MAC TEXTA
   byte {16},{3},{5},{7},{9},{11},{13},{15}
  ENDM
  MAC TEXTB
   byte {1},{2},{4},{6},{8},{10},{12},{14}
  ENDM


  MAC SLEEP
    IF {1} = 1
      ECHO "ERROR: SLEEP 1 not allowed !"
      END
    ENDIF
    IF {1} & 1
      nop $00
      REPEAT ({1}-3)/2
        nop
      REPEND
    ELSE
      REPEAT ({1})/2
        nop
      REPEND
    ENDIF
  ENDM



   MAC TEXTDISP
	lda #11
	sta NUSIZ1
	sta VDELP1
	lda charg+{1}	;3
	sta ENAM0		;3
	lsr				;2
	sta ENAM1		;3
	lsr				;2
	sta ENABL		;3
	lda charf+{1} 	;3
	sta GRP0			;3
	lda chare+{1}	;3
	sta GRP1			;3
	nop
	lda chard+{1}	;3
	sta GRP0			;3
	lda charc+{1}	;3
	ldy charb+{1}	;3
	ldx chara+{1}	;3
	sta GRP1			;3
	sty GRP0			;3
	stx GRP1			;3
	sta VDELP1		;3
	lda #4
	sta NUSIZ1
	lda charp+{1}	;3
	sta GRP1
   ENDM



invDisp

	lda INTIM
	bne invDisp
	ldx #195
wasteLines
	sta WSYNC
	dex
	bne wasteLines
	jmp rtnInvDisp

        lda #$28
        sta COLUP0
        lda #$28
        sta COLUP1
        lda #255
        sta PF0
        lda #$f0
        sta PF1
        lda #0
        sta PF2

        lda #%00000101
        sta CTRLPF
        sta WSYNC
        sta GRP0
        sta GRP1
        lda #$03           ; set both players to 3 copies
        sta NUSIZ0
        sta NUSIZ1
        lda #$01           ; set vertical delay on for both players
        sta VDELP0
        sta RESM0
        sta RESM1
        sta VDELP1
        sta RESBL
        sta RESP0
        sta RESP1
        lda #%11110000
        sta HMP1
        lda #%11100000
        sta HMP0
        lda #%10000000
        sta HMBL
        lda #%10110000
        sta HMM0
        lda #%01010000
        sta HMM1
        sta WSYNC
        sta HMOVE
	lda #0
	sta GRP0
	sta GRP1
	sta GRP0
	sta GRP1
	sta ENAM0
	sta ENAM1

        lda lineCol2
        sta COLUBK

pictureLoop
        lda INTIM       ;check timer for end of VBLANK period
        bne pictureLoop ;loop until it reaches 0

        sta WSYNC
        lda #$80
        sta VBLANK      ;end screen blank

        ; Set playfield color
        lda #$28
        sta COLUPF

        lda #0
        sta line

        lda #0
        sta textptr

        tsx
        stx savesp
        
;        SLEEP 10

        jmp mainTextLoop        ;3

; put this here so we can jump out of the main text loop
; using a 2-cycle relative branch.


        ;------------------------------------------------------------------

	align 256
quitTextLoop

        lda #0
        sta GRP0
        sta GRP1
        sta GRP0
        sta GRP1
        sta ENAM0
        sta ENAM1
        sta ENABL

; restore stack pointer

        ldx savesp
        txs


        ldx #11

charScanLoop
        sta WSYNC
        dex
        bne charScanLoop

        sta COLUPF

	jmp rtnInvDisp


mainTextLoop

; set up the stack for building screen data

        ldx #chars      ;2
        txs             ;2

; load the first text character
; note: x and y are reversed!
        ldy textptr      ;3
        ldx text,y       ;4
        beq quitTextLoop ;2 ->4   ; look for terminating character (0)
        iny              ;2

; build screen data for first character

        lda fontlo,x    ;4
        pha             ;3
        lda fontlo+1,x  ;4
        pha             ;3
        lda fontlo+2,x  ;4
        pha             ;3
        lda fontlo+3,x  ;4
        pha             ;3
        lda fontlo+4,x  ;4
        pha             ;3

; loop through the remaining 6 character pairs
textLineLoop

; load the next two text characters

        ldx text,y      ;4
        lda text1,y     ;4
        iny             ;2
        sty textptr     ;3
        tay             ;2

; build screen data for next two characters

        lda fonthi,x    ;4
        ora fontlo,y    ;4
        pha             ;3
        lda fonthi+1,x  ;4
        ora fontlo+1,y  ;4
        pha             ;3
        lda fonthi+2,x  ;4
        ora fontlo+2,y  ;4
        pha             ;3
        lda fonthi+3,x  ;4
        ora fontlo+3,y  ;4
        pha             ;3
        lda fonthi+4,x  ;4
        ora fontlo+4,y  ;4
        pha             ;3

; next character pair
        ldy textptr      ;3
        tsx              ;2
        bmi textLineLoop ;2

; now render it asap

        ldx line       ;3
        inx            ;2
        stx line       ;3
        lda lineCol,x  ;4
        sta COLUBK     ;3

        dec $2d
        dec $2d
        dec $2d
        dec $2d
        dec $2d
        dec $2d

        TEXTDISP 0,0
        TEXTDISP 1,2
        TEXTDISP 2,4
        TEXTDISP 3,6
        TEXTDISP 4,8

        lda #0    ;2
;        sta COLUP0      ;3
;        sta COLUP1      ;3
        sta GRP0  ;3
        sta GRP1  ;3
        sta GRP0  ;3
        sta ENAM0 ;3
        sta ENAM1 ;3
        sta ENABL ;3
        ldx line       ;3
        lda lineCol2,x ;4
        sta COLUBK     ;3

        SLEEP 11        ; 15+23+12

	jmp mainTextLoop  ;3

lineCol
	byte $12,$12,$24,$22,$22,$22,$22,$22,$22,$22,$32,$32,$32,$32
lineCol2
	byte $10,$10,$20,$20,$20,$20,$20,$20,$20,$20,$30,$30,$30,$30

        align 256

  MAC TEXT
	TEXT{1} s,t,r,o,n,g,s,a,d,_,_,_,_,_,_,0
	TEXT{1} i,n,v,e,n,t,o,r,yy,_,_,_,_,_,_,0
	TEXT{1} b,r,o,a,d,_,s,w,o,r,d,_,_,plus,_2,0
	TEXT{1} t,h,e,_,s,t,i,c,k,_,_,_,_,plus,_5,0
	TEXT{1} w,o,o,d,e,n,_,s,h,i,e,l,d,min,_1,0
	TEXT{1} m,e,t,a,l,_,h,e,l,m,e,t,_,min,_1,0
	TEXT{1} s,m,i,t,h,s,_,c,d,_,_,_,_,n,a,0
	TEXT{1} f,o,n,d,u,e,_,p,o,t,_,_,_,n,a,0
	TEXT{1} f,h,q,w,h,g,a,d,s,_,_,_,_,plus,_7,0
	TEXT{1} m,e,l,o,n,a,d,e,_,_,_,_,_,_2,_1,0
	TEXT{1} g,o,l,d,_,n,u,g,g,e,t,s,_,_3,_5,0
	TEXT{1} m,a,r,s,h,m,e,l,l,o,w,s,_,_1,_5,0
	TEXT{1} w,h,i,t,e,_,m,a,j,i,c,k,s,_8,_3,0
  ENDM

text
   TEXT B
text1
   TEXT A

